<html>
<head>
<title>OgreGLSLESProgramManagerCommon.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_740c5ae02f3e58539fc77518d7d26661.html">GLES2</a>      </li>
      <li class="navelem"><a class="el" href="dir_869fcd4d0767bf0c6544e0566078ca07.html">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_9c8668f5b14e7779923b4ed363e11a4e.html">GLSLES</a>      </li>
      <li class="navelem"><a class="el" href="dir_84d626bd39fc7a71e1d66527f3ce1f64.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLSLESProgramManagerCommon.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLSLESProgramManagerCommon_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __GLSLESProgramManagerCommon_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __GLSLESProgramManagerCommon_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLES2Prerequisites_8h.html">OgreGLES2Prerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLSLESProgramCommon_8h.html">OgreGLSLESProgramCommon.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLSLESExtSupport_8h.html">OgreGLSLESExtSupport.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="preprocessor">#if !OGRE_NO_GLES2_GLSL_OPTIMISER</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#   include &quot;glsl_optimizer.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#endif</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00040"></a>00040 <span class="keyword">namespace </span>Ogre {
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00054"></a><a class="code" href="classOgre_1_1GLSLESProgramManagerCommon.html">00054</a>     <span class="keyword">class </span><a class="code" href="OgreGLES2Prerequisites_8h.html#a3f2e060c56216a4f3fb7650e502f5735">_OgreGLES2Export</a> <a class="code" href="classOgre_1_1GLSLESProgramManagerCommon.html" title="Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL ES has one pr...">GLSLESProgramManagerCommon</a>
<a name="l00055"></a>00055     {
<a name="l00056"></a>00056     <span class="keyword">protected</span>:
<a name="l00058"></a><a class="code" href="classOgre_1_1GLSLESProgramManagerCommon.html#ad6a666ba0e4312cec7113fe617d951e3">00058</a>         <a class="code" href="classOgre_1_1GLSLESGpuProgram.html" title="GLSL ES low level compiled shader object - this class is used to get at the linked program object and...">GLSLESGpuProgram</a>* <a class="code" href="classOgre_1_1GLSLESProgramManagerCommon.html#ad6a666ba0e4312cec7113fe617d951e3" title="Active objects defining the active rendering gpu state.">mActiveVertexGpuProgram</a>;
<a name="l00059"></a><a class="code" href="classOgre_1_1GLSLESProgramManagerCommon.html#a11183e2ef747ebb357d7d3d28b5d95df">00059</a>         <a class="code" href="classOgre_1_1GLSLESGpuProgram.html" title="GLSL ES low level compiled shader object - this class is used to get at the linked program object and...">GLSLESGpuProgram</a>* <a class="code" href="classOgre_1_1GLSLESProgramManagerCommon.html#a11183e2ef747ebb357d7d3d28b5d95df">mActiveFragmentGpuProgram</a>;
<a name="l00060"></a>00060 
<a name="l00061"></a><a class="code" href="classOgre_1_1GLSLESProgramManagerCommon.html#a7384fc46c60ddbd4e0070942dfaf6850">00061</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, GLenum&gt;::type</a> <a class="code" href="classOgre_1_1GLSLESProgramManagerCommon.html#a7384fc46c60ddbd4e0070942dfaf6850">StringToEnumMap</a>;
<a name="l00062"></a><a class="code" href="classOgre_1_1GLSLESProgramManagerCommon.html#afeddc48851b31cceed65f7d0ad879180">00062</a>         <a class="code" href="classOgre_1_1GLSLESProgramManagerCommon.html#a7384fc46c60ddbd4e0070942dfaf6850">StringToEnumMap</a> <a class="code" href="classOgre_1_1GLSLESProgramManagerCommon.html#afeddc48851b31cceed65f7d0ad879180">mTypeEnumMap</a>;
<a name="l00063"></a>00063 <span class="preprocessor">#if !OGRE_NO_GLES2_GLSL_OPTIMISER</span>
<a name="l00064"></a><a class="code" href="classOgre_1_1GLSLESProgramManagerCommon.html#a014c27ca722e63bd51ab750558103b38">00064</a> <span class="preprocessor"></span>        <span class="keyword">struct </span>glslopt_ctx *<a class="code" href="classOgre_1_1GLSLESProgramManagerCommon.html#a014c27ca722e63bd51ab750558103b38">mGLSLOptimiserContext</a>;
<a name="l00065"></a>00065 <span class="preprocessor">#endif</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span>
<a name="l00067"></a>00067         <span class="keywordtype">void</span> completeDefInfo(GLenum gltype, <a class="code" href="structOgre_1_1GpuConstantDefinition.html" title="Information about predefined program constants.">GpuConstantDefinition</a>&amp; defToUpdate);
<a name="l00069"></a>00069         <span class="keywordtype">bool</span> completeParamSource(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; paramName,
<a name="l00070"></a>00070             <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a>* vertexConstantDefs, 
<a name="l00071"></a>00071             <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a>* fragmentConstantDefs,
<a name="l00072"></a>00072             <a class="code" href="structOgre_1_1GLUniformReference.html" title="Structure used to keep track of named uniforms in the linked program object.">GLUniformReference</a>&amp; refToUpdate);
<a name="l00073"></a>00073 
<a name="l00074"></a>00074     <span class="keyword">public</span>:
<a name="l00075"></a>00075 
<a name="l00076"></a>00076         <a class="code" href="classOgre_1_1GLSLESProgramManagerCommon.html" title="Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL ES has one pr...">GLSLESProgramManagerCommon</a>(<span class="keywordtype">void</span>);
<a name="l00077"></a>00077         ~<a class="code" href="classOgre_1_1GLSLESProgramManagerCommon.html" title="Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL ES has one pr...">GLSLESProgramManagerCommon</a>(<span class="keywordtype">void</span>);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 <span class="preprocessor">#if !OGRE_NO_GLES2_GLSL_OPTIMISER</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span>
<a name="l00083"></a>00083         <span class="keywordtype">void</span> optimiseShaderSource(<a class="code" href="classOgre_1_1GLSLESGpuProgram.html" title="GLSL ES low level compiled shader object - this class is used to get at the linked program object and...">GLSLESGpuProgram</a>* gpuProgram);
<a name="l00084"></a>00084 <span class="preprocessor">#endif</span>
<a name="l00085"></a>00085 <span class="preprocessor"></span>
<a name="l00097"></a>00097         <span class="keywordtype">void</span> extractUniforms(GLuint programObject, 
<a name="l00098"></a>00098             <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a>* vertexConstantDefs, 
<a name="l00099"></a>00099             <span class="keyword">const</span> <a class="code" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">GpuConstantDefinitionMap</a>* fragmentConstantDefs,
<a name="l00100"></a>00100             <a class="code" href="namespaceOgre.html#a24aca8d208dcf62fbe3bee9e759ac73d">GLUniformReferenceList</a>&amp; <a class="code" href="structOgre_1_1list.html">list</a>);
<a name="l00107"></a>00107         <span class="keywordtype">void</span> extractConstantDefs(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; src, <a class="code" href="structOgre_1_1GpuNamedConstants.html" title="Struct collecting together the information for named constants.">GpuNamedConstants</a>&amp; constantDefs, 
<a name="l00108"></a>00108             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename);
<a name="l00109"></a>00109     };
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 }
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 <span class="preprocessor">#endif // __GLSLESProgramManagerCommon_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
